unit ibase;

interface
 uses Windows;

const
 InterBaseDLL = 'gds32.dll'; // API InterBase
//**********************************************************
//     
//**********************************************************
 isc_dpb_version1  = 1;
 isc_dpb_user_name     = 28;  //  31 
 isc_dpb_password      = 29;  //  31 
 isc_dpb_lc_ctype      = 48;  // 
 isc_dpb_sql_role_name = 60;  // 

//**********************************************************
//    
//**********************************************************
 isc_tpb_version3       = 3; //   TPB     
 isc_tpb_consistency    = 1;
 isc_tpb_concurrency    = 2;
 isc_tpb_shared         = 3;
 isc_tpb_protected      = 4;
 isc_tpb_exclusive      = 5;
 isc_tpb_wait           = 6;
 isc_tpb_nowait         = 7;
 isc_tpb_read           = 8;
 isc_tpb_write          = 9;
 isc_tpb_lock_read      = 10;
 isc_tpb_lock_write     = 11;
 isc_tpb_read_committed	= 15;
 isc_tpb_autocommit	= 16;
 isc_tpb_rec_version	= 17;
 isc_tpb_no_rec_version	= 18;

//**********************************************************
//     DSQL .
//**********************************************************
 VALUE_IS_NULL  =-1;
 VALUE_NOT_NULL = 0;
 DSQL_close     = 1;
 DSQL_drop      = 2;
 SQLDA_VERSION1	= 1;
 SQL_TEXT       = 452;
 SQL_VARYING    = 448;
 SQL_SHORT      = 500;
 SQL_LONG       = 496;
 SQL_FLOAT      = 482;
 SQL_DOUBLE     = 480;
 SQL_D_FLOAT    = 530;
 SQL_DATE       = 510;
 SQL_BLOB       = 520;
 SQL_ARRAY      = 540;
 SQL_QUAD       = 550;
//  Interbase  6.0
 SQL_TIMESTAMP  = 510;
 SQL_TYPE_TIME  = 560;
 SQL_TYPE_DATE  = 570;

//**********************************************************
// .
//**********************************************************
 isc_segment     =  335544366;
 isc_segstr_eof  =  335544367;

//**********************************************************
//    status_vector
//**********************************************************
 isc_arg_end         =0;
 isc_arg_gds         =1;
 isc_arg_string      =2;
 isc_arg_cstring     =3;
 isc_arg_interpreted =5;

 maxForXSQLVAR   = 31; //   XSQLVAR 

type
 isc_db_handle = Pointer;  //database handle
 isc_tr_handle = Pointer;  //transaction handle
 isc_blob_handle = Pointer; //blob handle
 ISC_TEB = record          //  isc_start_multiple
  db_handle  : Pointer;    //   database handle
  tpb_length : LongInt;    // TPB 
  tpb_       : PChar;      //TPB 
 end;
 XSQLVAR = record
  sqltype          : SmallInt;  //   
  sqlscale         : SmallInt;  // 
  sqlsubtype       : SmallInt;  //  Blob 
  sqllen           : SmallInt;  //     sqldata
  sqldata          : PChar;     //  
  sqlind           : Pointer; //  
  sqlname_length   : SmallInt;  //  sqlname
  sqlname          : array [0..maxForXSQLVAR] of char; // ,   #0
  relname_length   : SmallInt;  //  relname
  relname          : array [0..maxForXSQLVAR] of char; // ,   #0
  ownname_length   : SmallInt;  //  ownname
  ownname          : array [0..maxForXSQLVAR] of char; //  ,   #0
  aliasname_length : SmallInt; 	//  aliasname
  aliasname        : array [0..maxForXSQLVAR] of char; // ,   #0
 end;
 XSQLDA = record
  version : SmallInt;              //  XSQLDA .     SQLDA_VERSION1
  sqldaid : array [0..7] of char;  //   
  sqldabc : integer;               //   
  sqln    : SmallInt;	             //    sqlvar
  sqld    : SmallInt;		           // ,  isc_dsql_describe(), isc_dsql_describe_bind(), isc_dsql_prepare()
  sqlvar  : array [0..0] of XSQLVAR; //   XSQLVAR
 end;
 isc_stmt_handle = Pointer; //statement handle
 ISC_STATUS    = LongInt;
 ISC_LONG      = LongInt;
 ISC_CALLBACK_EVENT  = procedure(result : PChar; length_ : short; updated : PChar); cdecl;
 ISC_QUAD = record //  ID Blob
  gds_quad_high : LongInt;
  gds_quad_low  : DWord;
 end;
 TCTimeStructure = record
   sec_   : integer; // 
   min_   : integer; // 
   hour_  : integer; //   0  23
   mday_  : integer; //    1  31
   month_ : integer; //   0  11
   year_  : integer; //   1900
   wday_  : integer; //    0  6.  = 0
   yday_  : integer; //    0  365
   isdst_ : integer; // 0    
 end;
 p_TCTimeStructure = ^TCTimeStructure;
//     Interbase 6.0
 ISC_DATE = LongInt;
 ISC_TIME = Longword;
 ISC_TIMESTAMP =record
  timestamp_date : ISC_DATE;
  timestamp_time : ISC_TIME;
 end;
 p_ISC_TIMESTAMP =^ISC_TIMESTAMP;

//**********************************************************
//      
//**********************************************************
//    
function isc_attach_database(P_ISC_STATUS   : Pointer;   //  status_vector
                             db_length_name : SmallInt;  // +  
                             db_name        : PChar;     //+  
                             db_handle      : Pointer;   //   handle database
                             dpb_length     : SmallInt;  // DPB 
                                                         //DPB 
                             dpb            : PChar) : ISC_STATUS; stdcall; external InterBaseDLL;

//    
function isc_detach_database(P_ISC_STATUS : Pointer;     //  status_vector
                                                         //   handle database
                             db_handle    : Pointer) : ISC_STATUS; stdcall; external InterBaseDLL;

{
    DPB   
     
 a. isc_dpb_user_name
 b. isc_dpb_password
 c. isc_dpb_lc_message (       )
 d. isc_dpb_lc_ctype   (       )
}
procedure isc_expand_dpb(P_dpb        : Pointer; //   dpb
                         P_length_dpb : Pointer; //     dpb 
                         type_        : SmallInt;// 
                         value_        : PChar;  // 
                                                 //    
                         SignOfEnd : pointer = nil); cdecl; external InterBaseDLL;

{
      -,  ,
  , shadow   log .
}
function isc_drop_database(P_ISC_STATUS : Pointer; //  status_vector
                                                   //   handle database
                           db_handle    : Pointer) : ISC_STATUS; stdcall; external InterBaseDLL;

//**********************************************************
//  
//**********************************************************
{
  commit     
   
}
function isc_commit_retaining(P_ISC_STATUS : Pointer; //  status_vector
                                                      //   transaction handle
                              tr_handle    : Pointer) : ISC_STATUS; stdcall; external InterBaseDll;

//  commit   
function isc_commit_transaction(P_ISC_STATUS : Pointer; //  status_vector
                                                        //   transaction handle
                                tr_handle    : Pointer) : ISC_STATUS; stdcall; external InterBaseDll;

// roll back   
function isc_rollback_transaction(P_ISC_STATUS : Pointer; //  status_vector
                                                          //   transaction handle
                                  tr_handle    : Pointer) : ISC_STATUS; stdcall; external InterBaseDll;

{
   ,     
  .    ,   
      .
}
function isc_start_multiple(P_ISC_STATUS : Pointer;  //  status_vector
                            tr_handle    : Pointer;  //   transaction handle
                            db_count     : SmallInt; // ,     .    ISC_TEB .
                                                     //   ISC_TEB .
                            P_ISC_TEB    : Pointer) : ISC_STATUS; stdcall; external InterBaseDll;

//  ,     
function isc_start_transaction(P_ISC_STATUS : Pointer;  //  status_vector
                               tr_handle    : Pointer;  //   transaction handle
                               db_count     : SmallInt; // ,     .    ISC_TEB .
                               db_handle    : Pointer;  //   database handle
                               tpb_length   : Integer; // TPB 
                                                        //TPB 
                               tpb_         : PChar) : ISC_STATUS; cdecl; external InterBaseDll;

{
  DSQL.
      . .
}
function isc_dsql_execute_immediate(P_ISC_STATUS : Pointer;  //  status_vector
                                    db_handle    : Pointer;  //   database handle
                                    tr_handle    : Pointer;  //   transaction handle
                                    length_str   : SmallInt; // 0 -   #0,   
                                    str_DSQL     : string;   // DSQL  
                                    dialect      : SmallInt; //  XSQLDA     1
                                                             //   XSQLDA,     nil
                                    P_XSQLDA     : Pointer) : ISC_STATUS; stdcall; external InterBaseDll;
{
   statement handle  
 . ,   statement handle
      nil
}
function isc_dsql_allocate_statement(P_ISC_STATUS : Pointer;  //  status_vector
                                     db_handle    : Pointer;  //   database handle
                                                              //   statement handle
                                     stmt_handle  : Pointer) : ISC_STATUS; stdcall; external InterBaseDll;

{
    DSQL   
 .
}
function isc_dsql_prepare(P_ISC_STATUS : Pointer; //  status_vector
                          tr_handle    : Pointer; //   transaction handle
                          stmt_handle  : Pointer; //   statement handle
                          length_str   : SmallInt;// 0 -   #0,   
                          str_DSQL     : string;  // DSQL  
                          dialect      : SmallInt;//  XSQLDA     1
                                                  //   XSQLDA,     nil
                          P_XSQLDA     : Pointer) : ISC_STATUS; stdcall; external InterBaseDll;

//   DSQL .
function isc_dsql_execute(P_ISC_STATUS : Pointer; //  status_vector
                          tr_handle    : Pointer; //   transaction handle
                          stmt_handle  : Pointer; //   statement handle
                          dialect      : SmallInt;//  XSQLDA     1
                                                  //   XSQLDA,     nil
                          P_XSQLDA     : Pointer) : ISC_STATUS; stdcall; external InterBaseDll;

//     DSQL 
function isc_dsql_describe_bind(P_ISC_STATUS : Pointer; //  status_vector
                                stmt_handle  : Pointer; //   statement handle
                                dialect      : SmallInt;//  SQL descriptor area.     1.
                                                        //   XSQLDA.
                                P_XSQLDA     : Pointer) : ISC_STATUS; stdcall; external InterBaseDll;

//  statement handle   .
function isc_dsql_free_statement(P_ISC_STATUS : Pointer; //  status_vector
                                 stmt_handle  : Pointer; //   statement handle
                                                         // DSQL_close  DSQL_drop.
                                                         //  ,    .
                                                         // DSQL_drop  statement handle   ,
                                                         // DSQL_close     statement handle
                                 option_      : SmallInt) : ISC_STATUS; stdcall; external InterBaseDll;

{
   XSQLDA.
    .
}
function XSQLDA_LENGTH(n: LongInt): LongInt;

//       DSQL 
function isc_dsql_set_cursor_name(P_ISC_STATUS : Pointer; //  status_vector
                                  stmt_handle  : Pointer; //   statement handle
                                  cursor_name  : string;  // 
                                                          //   .   0.
                                  type_        : SmallInt) : ISC_STATUS; stdcall; external InterBaseDll;

{
     
DSQL .
}
function isc_dsql_fetch(P_ISC_STATUS : Pointer; //  status_vector
                        stmt_handle  : Pointer; //   statement handle
                        dialect      : SmallInt;//  XSQLDA     1
                                                //   XSQLDA.
                        P_XSQLDA     : Pointer) : ISC_STATUS; stdcall; external InterBaseDll;

{
   ,  
DSQL .
}
function isc_dsql_describe(P_ISC_STATUS : Pointer; //  status_vector
                           stmt_handle  : Pointer; //   statement handle
                           dialect      : SmallInt;//  XSQLDA     1
                                                   //   XSQLDA.
                           P_XSQLDA     : Pointer) : ISC_STATUS; stdcall; external InterBaseDll;

{
  DSQL    
 .
}
function isc_dsql_execute2(P_ISC_STATUS : Pointer; //  status_vector
                           tr_handle    : Pointer; //   transaction handle
                           stmt_handle  : Pointer; //   statement handle
                           dialect      : SmallInt;//  XSQLDA     1
                           pin_XSQLDA   : Pointer; //   XSQLDA   .
                                                   //   XSQLDA   .
                           pout_XSQLDA  : Pointer) : ISC_STATUS; stdcall; external InterBaseDll;

{
    DSQL . DSQL 
        
 .      
'EXECUTE PROCEDURE'.
}
function isc_dsql_exec_immed2(P_ISC_STATUS : Pointer;  //  status_vector
                              db_handle    : Pointer;  //   database handle
                              tr_handle    : Pointer;  //   transaction handle
                              length_str   : SmallInt; // 0 -   #0,   
                              str_DSQL     : string;   // DSQL  
                              dialect      : SmallInt; //  XSQLDA     1
                              PIn_XSQLDA   : Pointer;  //   XSQLDA   ,     nil
                                                       //   XSQLDA   ,     nil
                              POut_XSQLDA  : Pointer) : ISC_STATUS; stdcall; external InterBaseDll;

//**********************************************************
//   blob 
//**********************************************************
{
   Blob    .
}
function isc_open_blob2(P_ISC_STATUS : Pointer;  //  status_vector
                        db_handle    : Pointer;  //   database handle
                        tr_handle    : Pointer;  //   transaction handle
                        blob_handle  : Pointer;  //   blob handle,      nil
                        PISC_QUAD    : Pointer;  //   ISQ_QUAD
                        bpb_length   : SmallInt; // BPB,      0
                                                 //Blob parametr buffer(BPB)
                        bpb_address  : string) : ISC_STATUS; stdcall; external InterBaseDll;

{
    Blob 
}
function isc_get_segment(P_ISC_STATUS : Pointer;  //  status_vector
                         blob_handle  : Pointer;  //   blob handle
                         actual_seg_length : Pointer; //    SmallInt      .
                                                      //         .
                         seg_buffer_length : SmallInt; //    
                                                  //     
                         seg_buffer  : PChar) : ISC_STATUS; stdcall; external InterBaseDll;

{
  Blob . Blob handle   
}
function isc_close_blob(P_ISC_STATUS : Pointer; //  status_vector
                                                //   blob handle
                         blob_handle  : Pointer) : ISC_STATUS; stdcall; external InterBaseDll;

{
   Blob    
}
function isc_create_blob2(P_ISC_STATUS : Pointer;  //  status_vector
                          db_handle    : Pointer;  //   database handle
                          tr_handle    : Pointer;  //   transaction handle
                          blob_handle  : Pointer;  //   blob handle
                          PISC_QUAD    : Pointer;  //   ISQ_QUAD
                          bpb_length   : SmallInt; // BPB,      0
                                                   //Blob parametr buffer(BPB),     nil
                          bpb_address  : PChar) : ISC_STATUS; stdcall; external InterBaseDll;

{
   Blob segment
}
function isc_put_segment(P_ISC_STATUS : Pointer;  //  status_vector
                         blob_handle  : Pointer;  //   blob handle
                         seg_buffer_length : SmallInt; //    
                                                  //     
                         seg_buffer  : string) : ISC_STATUS; stdcall; external InterBaseDll;

{
 Blob,      Blob handle  nul
}
function isc_cancel_blob(P_ISC_STATUS : Pointer; //  status_vector
                                                //   blob handle
                         blob_handle  : Pointer) : ISC_STATUS; stdcall; external InterBaseDll;

//**********************************************************
//   
//**********************************************************
{    ,    PISC_QUAD
   TCTimeStructure,    PTCTimeStructure}
procedure isc_decode_date(PISC_QUAD : Pointer;       //   ISQ_QUAD
                          PTCTimeStructure : Pointer //   TCTimeStructure
                          ); stdcall; external InterBaseDll;

{    TCTimeStructure    PTCTimeStructure
       PISC_QUAD}
procedure isc_encode_date(PTCTimeStructure : Pointer; //   TCTimeStructure
                          PISC_QUAD : Pointer         //   ISQ_QUAD
                          ); stdcall; external InterBaseDll;

//          Interbase 6.0
//------------------------------------------------------------------------------

{    ISC_DATE,    ib_date
   TCTimeStructure,    c_date}
procedure isc_decode_sql_date(ib_date : Pointer; //   ISC_DATE
                               c_date : Pointer  //   TCTimeStructure
                              ); stdcall; external InterBaseDll;

{    TCTimeStructure    c_date
   ISC_DATE    ib_date}
procedure isc_encode_sql_date(c_date : Pointer;  //   TCTimeStructure
                              ib_date : Pointer  //   ISC_DATE
                             ); stdcall; external InterBaseDll;

{     Interbase  TIMESTAMP   TCTimeStructure}
procedure isc_decode_timestamp(ib_timestamp : p_ISC_TIMESTAMP;
                               tm_date : p_TCTimeStructure); stdcall; external InterBaseDll;

{      TCTimeStructure   TIMESTAMP}
procedure isc_encode_timestamp(tm_date : p_TCTimeStructure;
                               ib_timestamp : p_ISC_TIMESTAMP); stdcall; external InterBaseDll;
//*************************************************************
//    Events
//*************************************************************
{         events.
        15 events}
function isc_event_block(event_buffer   : Pointer;       //    (   PChar)
                         result_buffer  : Pointer;       //    (   PChar)
                         id_count       : Word;          //   (events)
                         event1,event2,event3,
                         event4,event5,event6,
                         event7,event8,event9,
                         event10,event11,event12,
                         event13,event14,event15 : PChar //  (events)
                        ) : ISC_LONG; cdecl; external InterBaseDll;

{    events.      
 .        cdel.}
function isc_que_events(P_ISC_STATUS       : Pointer;            //  status_vector
                        db_handle          : Pointer;            //   database handle
                        event_id           : Pointer;            //    LongInt
                                                                 //     isc_cancel_events
                        length_            : Short;              // event   isc_event_block
                        event_buffer       : PChar;              //event_buffer   isc_event_buffer
                        event_function     : ISC_CALLBACK_EVENT; //    
                        event_function_arg : pointer             //       event_function
                                                                 //      isc_event_block
                       ) : ISC_STATUS;  stdcall; external InterBaseDll;

{    events  .     status_vector
       .   event   
 isc_event_block    status_vector[0],    status_vector[1]  ..}
procedure isc_event_counts(P_ISC_STATUS  : Pointer; //  status_vector
                           buffer_length : Short;   // ,  isc_event_block
                           event_buffer  : PChar;   //event_buffer   isc_event_buffer
                           result_buffer : PChar    //result_buffer   isc_result_buffer
                         ); stdcall; external InterBaseDll;

{  event}
function isc_cancel_events(P_ISC_STATUS : Pointer; //  status_vector
                           db_handle    : Pointer; //   database handle
                           event_id     : Pointer //    isc_que_events
                          ) : ISC_STATUS; stdcall; external InterBaseDll;

function isc_interprete(str_ : PCHAR; P_ISC_STATUS : Pointer) : ISC_STATUS; stdcall; external InterBaseDLL;

{     event_buffer  result_buffer.
   }
function isc_free(p : PChar) : ISC_LONG; stdcall; external InterBaseDll;

implementation

function XSQLDA_LENGTH(n: LongInt): LongInt;
begin
  result := SizeOf(XSQLDA) + ((n - 1) * SizeOf(XSQLVAR));
end;


end.
