unit ibase_level1_server;

interface

uses ibase,classes,sysutils,Windows;

const

{    TText_Blob  
     .}
 DefaultSizeBuf_TText_Blob = 500;
{   }
 EndOfStr_TText_Blob = #13;

type

 TStatus_vector = array [0..19] of ISC_STATUS;
 TAccess_mode       = (none_mode,tpb_read,tpb_write);
 TIsolation_level   = (none_level,tpb_concurrency,tpb_consistency,tpb_read_committed_rec,tpb_read_committed_no_rec);
 TLock_resolution   = (none_resolution,tpb_wait,tpb_nowait);
 TTable_reservation = (tpb_shared_write,tpb_shared_read,tpb_protected_write,tpb_protected_read);
 TPointer_XSQLDA  = ^XSQLDA;
 TPointer_XSQLVAR = ^XSQLVAR;

{TItemReservation     (record),
        Delphi 4
      string  .
}
 TItemReservation = class(TObject)
  Table_reservation      : TTable_reservation;
  Name_table_reservation : string;
 end;

// DPB
 TParametrDPB = class(TObject)
  public
   user         : string;  //
   password     : string;  //
   CharacterSet : string;  // 
   role         : string;  //
   constructor Create;
   procedure Assign(Source : TParametrDPB); //   Source
 end;

// DPB
 TDPB = class(TObject)
  protected
   FParametrDPB : TParametrDPB;           // DPB
   Fpointer_DPB : pointer;                //  DPB
   FLength_DPB  : SmallInt;               // DPB
   function ReadUser         : string;    //
   function ReadPassword     : string;    //
   function ReadCharacterSet : string;    // 
   function ReadRole         : string;    //
  public
   property pointer_DPB : pointer read FPointer_DPB;
   property length_DPB : SmallInt read FLength_DPB;
   property user         : string read ReadUser;
   property password     : string read ReadPassword;
   property CharacterSet : string read ReadCharacterSet;
   property role         : string read ReadRole;
   constructor Create;
   destructor Destroy; override;
   procedure FillDPB(value : TParametrDPB); //  DPB
 end;

 TConnection = class(TObject)
  protected
   Fdb_handle : isc_db_handle;
   function GetPdb_handle : Pointer;
   function GetIsAttach : Boolean;
  public
   property IsAttach : Boolean read GetIsAttach;
   property db_handle : pointer read GetPdb_handle;
   constructor Create;
   destructor Destroy; override;
   procedure Attach(DPB : TDPB; name_base : string);
   procedure Detach; virtual;
 end;

 TParametrTPB = class(TObject)
  protected
   FItemsReservation : TList;
   function ReadItemsCount : Integer;
   function GetItem(index : integer) : TItemReservation;
  public
   Access_mode       : TAccess_mode;
   Isolation_level   : TIsolation_level;
   Lock_resolution   : TLock_resolution;
   property ItemsCount : integer read ReadItemsCount;              //  table reservation
   property Item[Index : Integer] : TItemReservation read GetItem; // index -   table reservation
   constructor Create;                                             //
   destructor Destroy; override;                                   //
   procedure AddItem(reservation : TTable_reservation; name : string); //  table reservation
   procedure DeleteItem(index : integer);                          //  table reservation   index
   procedure Clear;                                                //   table reservation
   procedure Assign(Source : TParametrTPB);
 end;

 TTPB = class(TObject)
  protected
   FPointerTPB  : Pointer;
   FLengthTPB   : LongInt;
   FParametrTPB : TParametrTPB;
   function ReadAccess_mode : TAccess_mode;
   function ReadIsolation_level : TIsolation_level;
   function ReadLock_resolution : TLock_resolution;
   function ReadCountResrvation : integer;
   function GetItemReservation(Index : Integer) : TItemReservation;
  public
   property PointerTPB : Pointer read FPointerTPB;
   property LengthTPB  : LongInt read FLengthTPB;
   property Access_mode      : TAccess_mode     read ReadAccess_mode;
   property Isolation_level  : TIsolation_level read ReadIsolation_level;
   property Lock_resolution  : TLock_resolution read ReadLock_resolution;
   property CountResrevation : integer read ReadCountResrvation;
   property ItemReservation[Index : Integer] : TItemReservation read GetItemReservation;
   constructor Create;
   destructor Destroy; override;
   procedure FillTPB(value : TParametrTPB);
 end;

 TTransaction = class(TObject)
  protected
   Ftr_handle : isc_tr_handle;
   function GetPTr_handle : pointer;
   function GetIsActiveTransaction : Boolean;
  public
   property IsActiveTransaction : Boolean read GetIsActiveTransaction;
   property tr_handle : pointer read GetPTr_handle; //  Ftr_handle
   constructor Create;
   destructor Destroy; override;
   procedure Start_transaction(Connect : TConnection;TPB : TTPB);
   procedure Commit_retaining;
   procedure Commit;
   procedure Rollback;
 end;

{
  ?     ?    
---------------------------------------------------
                                         1
                                          2
                                          3
                                           4
}

 TDSQL_metod = class(TObject)
  protected
   Fstmt_handle : isc_stmt_handle;
   Fstr_dsql : string;
   FTrans   : TTransaction;
  public
   property str_dsql : string read Fstr_dsql;
   constructor Create;
   destructor Destroy; override;
 end;

 TDSQL_metod1 = class(TDSQL_metod)
  public
   procedure Prepare(Connect : TConnection; Trans : TTransaction; str_ : string);
   procedure Execute;
 end;

 TXSQLDA = class(Tobject)
  protected
   Fpointer_XSQLDA : Tpointer_XSQLDA;
   function GetXSQLVAR(index : integer) : Tpointer_XSQLVAR;
  public
   property pointer_XSQLDA : Tpointer_XSQLDA read Fpointer_XSQLDA;
   property XSQLVAR_[Index : integer] : Tpointer_XSQLVAR read GetXSQLVAR;
   constructor Create(quan : integer);
   destructor Destroy; override;
 end;

 TDSQL_metod2 = class(TDSQL_metod)
  protected
   FXSQLDA : TXSQLDA;
   function GetCountParametr : integer;
   function GetParametr(index : integer) : Tpointer_XSQLVAR;
  public
   property CountParametr : integer read GetCountParametr;
   property Parametr[index : integer] : Tpointer_XSQLVAR read GetParametr;
   constructor Create;
   destructor Destroy; override;
   procedure Prepare(Connect : TConnection; Trans : TTransaction; str_ : string);
   procedure Execute;
 end;

 TDSQL_metod3 = class(TDSQL_metod)
  protected
   FIsOpen : Boolean;
   FEof : boolean;
   function GetCountFields : integer;
   function GetField(index : integer) : Tpointer_XSQLVAR;
  public
   FXSQLDA : TXSQLDA;
   property Eof : Boolean read FEof;
   property IsOpen : Boolean read FIsOpen;
   property CountFields : integer read GetCountFields;
   property Field[index : integer] : Tpointer_XSQLVAR read GetField;
   constructor Create;
   destructor Destroy; override;
   procedure Prepare(Connect : TConnection; Trans : TTransaction; str_ : string); virtual;
   procedure Open_cursor(cursor_name : string = ''); virtual;
   procedure Close_cursor;
   procedure Reopen_cursor(cursor_name : string = '');
   procedure Fetch;
 end;

 TDSQL_metod4 = class(TDSQL_metod3)
  protected
   FIsParametrs : boolean;
   InputXSQLDA  : TXSQLDA;
   function GetCountParametrs : integer;
   function GetParametr(index : integer) : Tpointer_XSQLVAR;
  public
   property CountParametrs : integer read GetCountParametrs;
   property Parametr[index : integer] : Tpointer_XSQLVAR read GetParametr;
   constructor Create(isParametr : boolean = true);
   destructor Destroy; override;
   procedure Prepare(Connect : TConnection; Trans : TTransaction; str_ : string); override;
   procedure Open_cursor(cursor_name : string = ''); override;
//        
   procedure ExecuteProc;
 end;

//      Blob 
 TText_Blob = class(TStringList)
  protected
   Fblob_handle : isc_blob_handle;
   Fdb_handle   : pointer;
   Ftr_handle   : pointer;
   FISC_QUAD    : ISC_QUAD;
  public
   property db_handle : pointer read Fdb_handle write Fdb_handle;
   property tr_handle : pointer read Ftr_handle write Ftr_handle;
   property id_blob : ISC_QUAD read FISC_QUAD write FISC_QUAD;

   constructor Create(db_handle_ : pointer = nil; tr_handle_ : pointer = nil);
   procedure Read_Blob(SizeBuffer : SmallInt = DefaultSizeBuf_TText_Blob);
   procedure Write_Blob;
 end;

//  Events
 TOnEvents =procedure(names_events : array of string);
 TIB_Events =class(TObject)
  protected
   FConnection       : TConnection;
   FEvent_buffer     : PChar;
   FResult_buffer    : PChar;
   FFlagRegistration : boolean;
   FEventsList       : TStringList;
   FEvent_id         : LongInt;
   FflagFirst        : boolean;
  public
   OnEvents : TOnEvents;
   property FlagRegistration : boolean read FFlagRegistration;
   constructor Create(connect : TConnection);
   destructor Destroy; override;
   procedure Registration(name_events : array of string);
   procedure UnRegistration;
 end;

//  
function ibDateTo(PISC_QUAD : pointer) : TDateTime;
procedure ToibDate(PISC_QUAD : pointer; value : TDateTime);
function TimestampTo(ib_date : p_ISC_TIMESTAMP) : TDateTime;
procedure ToTimestamp(ib_date : p_ISC_TIMESTAMP; value : TDateTime);
//          Interbase 6.0
function ibDateOnlyTo(ib_date : pointer) : TDateTime;
procedure ToIbDateOnly(ib_date : pointer; value : TDateTime);

function GetError(status_vector : TStatus_vector) : string;
procedure Execute_metod1(Connect : TConnection; Transac : TTransaction; str_ : string);
procedure Execute_metod2(Connect : TConnection; Transac : TTransaction; DSQLstr : string; InputXSQLDA,OutputXSQLDA : TXSQLDA);

var Interbase_dialect : SmallInt;

implementation

uses syncobjs,iberror,ibase_exception;

var
{       API InterBase,
 -     ,  API Interbase 
   .      
 Windows 98.}
 SectionAccessToInterBase : TCriticalSection;

function TimestampTo(ib_date : p_ISC_TIMESTAMP) : TDateTime;
var d : TCTimeStructure;
begin
 isc_decode_timestamp(ib_date,@d);
 Result :=EncodeDate(d.year_ + 1900,d.month_ + 1,d.mday_);
 Result :=Result + EncodeTime(d.hour_,d.min_,d.sec_,0);
end;

procedure ToTimestamp(ib_date : p_ISC_TIMESTAMP; value : TDateTime);
var d : TCTimeStructure;
    year_,month_,day_ : word;
    hour_,min_,sec_,msec_ : word;
begin
 DecodeDate(value,year_,month_,day_);
 DecodeTime(value,hour_,min_,sec_,msec_);
 d.sec_   :=sec_;
 d.min_   :=min_;
 d.hour_  :=hour_;
 d.mday_  :=day_;
 d.month_ :=month_ -1;
 d.year_  :=year_ - 1900;
 d.wday_  :=DayOfWeek(value) -1;
 d.yday_  :=Trunc(EncodeDate(year_,month_,day_) - EncodeDate(year_ -1,12,31));
 d.isdst_ :=1;
 isc_encode_timestamp(@d,ib_date);
end;

function ibDateTo(PISC_QUAD : pointer) : TDateTime;
var d : TCTimeStructure;
begin
 isc_decode_date(PISC_QUAD,@d);
 Result :=EncodeDate(d.year_ + 1900,d.month_ + 1,d.mday_);
// if d.isdst_ <> 0 then
   Result :=Result + EncodeTime(d.hour_,d.min_,d.sec_,0);
end;

procedure ToibDate(PISC_QUAD : pointer; value : TDateTime);
var d : TCTimeStructure;
    year_,month_,day_ : word;
    hour_,min_,sec_,msec_ : word;
begin
 DecodeDate(value,year_,month_,day_);
 DecodeTime(value,hour_,min_,sec_,msec_);
 d.sec_   :=sec_;
 d.min_   :=min_;
 d.hour_  :=hour_;
 d.mday_  :=day_;
 d.month_ :=month_ -1;
 d.year_  :=year_ - 1900;
 d.wday_  :=DayOfWeek(value) -1;
 d.yday_  :=Trunc(EncodeDate(year_,month_,day_) - EncodeDate(year_ -1,12,31));
 d.isdst_ :=1;
 isc_encode_date(@d,PISC_QUAD);
end;

function ibDateOnlyTo(ib_date : pointer) : TDateTime;
var d : TCTimeStructure;
begin
 isc_decode_sql_date(ib_date,@d);
 Result :=EncodeDate(d.year_ + 1900,d.month_ + 1,d.mday_);
end;

procedure ToIbDateOnly(ib_date : pointer; value : TDateTime);
var d : TCTimeStructure;
    year_,month_,day_ : word;
begin
 DecodeDate(value,year_,month_,day_);
 d.mday_  :=day_;
 d.month_ :=month_ -1;
 d.year_  :=year_ - 1900;
 d.wday_  :=DayOfWeek(value) -1;
 d.yday_  :=Trunc(EncodeDate(year_,month_,day_) - EncodeDate(year_ -1,12,31));
 d.isdst_ :=0;
 isc_encode_sql_date(@d,ib_date);
end;

function GetError(status_vector : TStatus_vector) : string;
begin
 SectionAccessToInterBase.Enter;
 try
  if Message_isc_error_rus <> nil
    then result :=Message_isc_error_rus.getMessage(status_vector)
    else result :=defaultMessage_isc_error_rus.getMessage(status_vector)
 finally
  SectionAccessToInterBase.Leave;
 end;
end;

constructor TParametrDPB.Create;
begin
 inherited Create;
 user         :='';
 password     :='';
 CharacterSet :='';
 role         :='';
end;

procedure TParametrDPB.Assign(Source : TParametrDPB);
begin
 user         :=Source.user;
 password     :=Source.password;
 CharacterSet :=Source.CharacterSet;
 role         :=Source.role;
end;

constructor TDPB.Create;
begin
 inherited Create;
 FParametrDPB := TParametrDPB.Create;
 Fpointer_DPB :=nil;
 FLength_DPB :=0;
end;

destructor TDPB.Destroy;
begin
 FParametrDPB.Free;
 if Fpointer_DPB <> nil then FreeMem(FPointer_DPB,FLength_DPB);
 inherited Destroy;
end;

function TDPB.ReadUser : string;
begin
 result :=FParametrDPB.user;
end;

function TDPB.ReadPassword : string;
begin
 result :=FParametrDPB.password;
end;

function TDPB.ReadCharacterSet : string;
begin
 result :=FParametrDPB.CharacterSet;
end;

procedure TDPB.FillDPB(value : TParametrDPB);
var new_length : SmallInt;
    a : ^Byte;
begin
 if Fpointer_DPB <> nil then begin
  FreeMem(Fpointer_DPB,Flength_DPB); // DPB
  Fpointer_DPB :=nil;                //  nil
  Flength_DPB :=0;                   // 0
 end;
//  
 new_length :=1;
 if value.user <> '' then new_length :=new_length + 2 + length(value.user);
 if value.password <> '' then new_length :=new_length + 2 + length(value.password);
 if value.CharacterSet <> '' then new_length :=new_length + 2 + length(value.CharacterSet);
 if value.role <> '' then new_length :=new_length + 2 + length(value.role);
//  DPB
 GetMem(Fpointer_DPB,new_length);
 Flength_DPB :=new_length;
// DPB
 a :=Fpointer_DPB;
 a^ :=isc_dpb_version1; Inc(a);
//  
 if value.user <> '' then begin
  a^ :=isc_dpb_user_name; Inc(a);
  a^ :=length(value.user);Inc(a);
  Move(Pointer(value.user)^,a^,length(value.user)); Inc(a,length(value.user));
 end;
// 
 if value.password <> '' then begin
  a^ :=isc_dpb_password;       Inc(a);
  a^ :=length(value.password); Inc(a);
  Move(Pointer(value.password)^,a^,length(value.password)); Inc(a,length(value.password));
 end;
//  
 if value.CharacterSet <> '' then begin
  a^ :=isc_dpb_lc_ctype;           Inc(a);
  a^ :=length(value.CharacterSet); Inc(a);
  Move(Pointer(value.CharacterSet)^,a^,length(value.CharacterSet)); Inc(a,length(value.CharacterSet));
 end;
// 
 if value.role <> '' then begin
  a^ :=isc_dpb_sql_role_name;      Inc(a);
  a^ :=length(value.role); Inc(a);
  Move(Pointer(value.role)^,a^,length(value.role));
 end;
 FParametrDPB.Assign(value); //  
end;

constructor TConnection.Create;
begin
 inherited Create;
 Fdb_handle :=nil;
end;

destructor TConnection.Destroy;
begin
 if Fdb_handle <> nil then raise EIbaseError.Create(' ');
 inherited Destroy;
end;

procedure TConnection.Attach(DPB : TDPB; name_base : string);
var status_vector : TStatus_vector;
    p : pointer;
    l : SmallInt;
begin
 if Fdb_handle <> nil then raise EIbaseError.Create('  ');
 if DPB = nil then begin
  p :=nil; l :=0;
 end else begin
  p :=DPB.Fpointer_DPB; l :=DPB.length_DPB;
 end;

 SectionAccessToInterBase.Enter;
 try
   isc_attach_database(@status_vector,length(name_base),PChar(name_base),@Fdb_handle,l,PChar(p));
 finally
   SectionAccessToInterBase.Leave;
 end;

 if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
end;

procedure TConnection.Detach;
var status_vector : TStatus_vector;
begin
// isc_detach_database  Fdb_handle  nil
 if Fdb_handle = nil then raise EIbaseError.Create('  ');
 SectionAccessToInterBase.Enter;

 try
   isc_detach_database(@status_vector,@Fdb_handle);
 finally
   SectionAccessToInterBase.Leave;
 end;

 if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
end;

function TConnection.GetPdb_handle : Pointer;
begin
 result :=@Fdb_handle;
end;

function TConnection.GetIsAttach : Boolean;
begin
 result :=(Fdb_handle <> nil);
end;

constructor TParametrTPB.Create;
begin
 inherited Create;
 FItemsReservation :=TList.Create;
 Access_mode       := none_mode;
 Isolation_level   := none_level;
 Lock_resolution   := none_resolution;
end;

destructor TParametrTPB.Destroy;
begin
 Clear;
 FItemsReservation.Free;
 inherited Destroy;
end;

procedure TParametrTPB.AddItem(reservation : TTable_reservation; name : string);
var p : TItemReservation;
begin
 p :=TItemReservation.Create;
 p.Table_reservation      := reservation;
 p.Name_table_reservation := name;
 FItemsReservation.Add(p);
end;

procedure TParametrTPB.DeleteItem(index : integer);
begin
 if (index < 0) or (index >= FItemsReservation.Count) then raise EIbaseError.Create('   index.');
 TItemReservation(FItemsReservation.Items[index]).Free;
 FItemsReservation.Delete(index);
end;

procedure TParametrTPB.Clear;
begin
 while FItemsReservation.Count > 0 do DeleteItem(0);
end;

function TParametrTPB.ReadItemsCount : Integer;
begin
 result :=FItemsReservation.Count;
end;

function TParametrTPB.GetItem(index : integer) : TItemReservation;
begin
 if (index < 0) or (index >= FItemsReservation.Count) then raise EIbaseError.Create('   index.');
 result :=TItemReservation(FItemsReservation.Items[index]);
end;

procedure TParametrTPB.Assign(Source : TParametrTPB);
var i : integer;
begin
 Access_mode       :=Source.Access_mode;
 Isolation_level   :=Source.Isolation_level;
 Lock_resolution   :=Source.Lock_resolution;
 Clear;
 for i :=0 to Source.ItemsCount -1 do
  AddItem(Source.Item[i].Table_reservation,Source.Item[i].Name_table_reservation);
end;

constructor TTPB.Create;
begin
 inherited Create;
 FParametrTPB := TParametrTPB.Create;
 FPointerTPB  := nil;
 FLengthTPB   := 0;
end;

destructor TTPB.Destroy;
begin
 FParametrTPB.Free;
 if FPointerTPB <> nil then FreeMem(FPointerTPB,FLengthTPB);
 inherited Destroy;
end;

function TTPB.ReadAccess_mode : TAccess_mode;
begin
 result :=FParametrTPB.Access_mode;
end;

function TTPB.ReadIsolation_level : TIsolation_level;
begin
 result :=FParametrTPB.Isolation_level;
end;

function TTPB.ReadLock_resolution : TLock_resolution;
begin
 result :=FParametrTPB.Lock_resolution;
end;

function TTPB.ReadCountResrvation : integer;
begin
 result :=FParametrTPB.ItemsCount;
end;

function TTPB.GetItemReservation(Index : Integer) : TItemReservation;
begin
 result :=FParametrTPB.Item[index];
end;

procedure TTPB.FillTPB(value : TParametrTPB);
var i,new_length : integer;
    a : ^Byte;
begin
// TPB
 if FPointerTPB <> nil then begin
  FreeMem(FPointerTPB,FLengthTPB);
  FPointerTPB :=nil;
  FLengthTPB :=0;
 end;
//  TPB
 new_length :=1;
 if value.Access_mode <> none_mode then Inc(new_length);
 if value.Lock_resolution <> none_resolution then Inc(new_length);
 case value.Isolation_level of
  tpb_concurrency           : Inc(new_length);
  tpb_consistency           : Inc(new_length);
  tpb_read_committed_rec    : Inc(new_length,2);
  tpb_read_committed_no_rec : Inc(new_length,2);
 end;
 for i :=0 to value.ItemsCount -1 do
  if Length(value.Item[i].Name_table_reservation) > 0 then
   new_length :=new_length + 3 + Length(value.Item[i].Name_table_reservation);
//  TPB
 GetMem(FPointerTPB,new_length);
 FLengthTPB :=new_length;
// TPB
 a :=FPointerTPB;
 a^ :=isc_tpb_version3; Inc(a);
// access mode
 case value.Access_mode of
  tpb_read  : begin a^ := isc_tpb_read;  Inc(a); end;
  tpb_write : begin a^ := isc_tpb_write; Inc(a); end;
 end;
// isolation level
 case value.Isolation_level of
  tpb_concurrency           : begin a^ := isc_tpb_concurrency; Inc(a); end;
  tpb_consistency           : begin a^ := isc_tpb_consistency; Inc(a); end;
  tpb_read_committed_rec    : begin a^ := isc_tpb_read_committed; Inc(a); a^ := isc_tpb_rec_version;    Inc(a); end;
  tpb_read_committed_no_rec : begin a^ := isc_tpb_read_committed; Inc(a); a^ := isc_tpb_no_rec_version; Inc(a); end;
 end;
// lock resolution
 case value.Lock_resolution of
  tpb_wait   : begin a^ :=isc_tpb_wait;   Inc(a); end;
  tpb_nowait : begin a^ :=isc_tpb_nowait; Inc(a); end;
 end;
// table reservation
 for i :=0 to value.ItemsCount -1 do
  if Length(value.Item[i].Name_table_reservation) > 0 then begin
   case value.Item[i].Table_reservation of
    tpb_shared_write    : begin a^ := isc_tpb_shared;    Inc(a); a^ :=isc_tpb_lock_write; Inc(a); end;
    tpb_shared_read     : begin a^ := isc_tpb_shared;    Inc(a); a^ :=isc_tpb_lock_read;  Inc(a); end;
    tpb_protected_write : begin a^ := isc_tpb_protected; Inc(a); a^ :=isc_tpb_lock_write; Inc(a); end;
    tpb_protected_read  : begin a^ := isc_tpb_protected; Inc(a); a^ :=isc_tpb_lock_read;  Inc(a); end;
   end;
   a^ :=Byte(length(value.item[i].Name_table_reservation)); Inc(a);
   Move(Pointer(value.item[i].Name_table_reservation)^,a^,length(value.item[i].Name_table_reservation)); Inc(a,length(value.item[i].Name_table_reservation));
  end;
 FParametrTPB.Assign(value); // 
end;

constructor TTransaction.Create;
begin
 inherited Create;
 Ftr_handle :=nil;
end;

destructor TTransaction.Destroy;
begin
 if Ftr_handle <> nil then raise EIbaseError.Create(' ');
 inherited Destroy;
end;

procedure TTransaction.Start_transaction(Connect : TConnection;TPB : TTPB);
var status_vector : TStatus_vector;
    p : pointer;
    l : integer;
begin
 if Ftr_handle <> nil then raise EIbaseError.Create('  ');
 if pointer(Connect.db_handle^) = nil then raise EIbaseError.Create('  ');
 if TPB = nil then begin
  p :=nil; l :=0;
 end else begin
  p :=TPB.PointerTPB; l :=TPB.LengthTPB;
 end;

 SectionAccessToInterBase.Enter;
 try
   isc_start_transaction(@status_vector,@Ftr_handle,1,Connect.db_handle,l,PChar(p));
 finally
   SectionAccessToInterBase.Leave;
 end;
 
 if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
end;

procedure TTransaction.Commit_retaining;
var Status_vector : TStatus_vector;
begin
 if Ftr_handle = nil then raise EIbaseError.Create('  ');

 SectionAccessToInterBase.Enter;
 try
   isc_commit_retaining(@status_vector,@Ftr_handle);
 finally
   SectionAccessToInterBase.Leave;
 end;

 if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
end;

procedure TTransaction.Commit;
var status_vector : TStatus_vector;
begin
 if Ftr_handle = nil then raise EIbaseError.Create('  ');

 SectionAccessToInterBase.Enter;
 try
   isc_commit_transaction(@status_vector,@Ftr_handle);
 finally
   SectionAccessToInterBase.Leave;
 end;

 if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
end;

procedure TTransaction.Rollback;
var status_vector : TStatus_vector;
begin
 if Ftr_handle = nil then raise EIbaseError.Create('  ');

 SectionAccessToInterBase.Enter;
 try
   isc_rollback_transaction(@status_vector,@Ftr_handle);
 finally
   SectionAccessToInterBase.Leave;
 end;

 if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
end;

function TTransaction.GetPTr_handle : pointer;
begin
 result :=@Ftr_handle;
end;

function TTransaction.GetIsActiveTransaction : Boolean;
begin
 result :=(Ftr_handle <> nil);
end;

procedure Execute_metod1(Connect : TConnection; Transac : TTransaction; str_ : string);
var status_vector : TStatus_vector;
begin
 SectionAccessToInterBase.Enter;
 try
   isc_dsql_execute_immediate(@status_vector,Connect.db_handle,Transac.tr_handle,0,str_,Interbase_dialect,nil);
   if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
 finally
   SectionAccessToInterBase.Leave;
 end;
end;

procedure Execute_metod2(Connect : TConnection; Transac : TTransaction; DSQLstr : string; InputXSQLDA,OutputXSQLDA : TXSQLDA);
var status_vector : TStatus_vector;
    P_XSQLDA1,P_XSQLDA2 : Pointer;
begin
 if InputXSQLDA <> nil
  then P_XSQLDA1 :=InputXSQLDA.pointer_XSQLDA
  else P_XSQLDA1 :=nil;
 if OutputXSQLDA <> nil
  then P_XSQLDA2 :=OutputXSQLDA.pointer_XSQLDA
  else P_XSQLDA2 :=nil;

 SectionAccessToInterBase.Enter;
 try
   isc_dsql_exec_immed2(@status_vector,Connect.db_handle,Transac.tr_handle,0,DSQLstr,Interbase_dialect,P_XSQLDA1,P_XSQLDA2);
 finally
   SectionAccessToInterBase.Leave;
 end;
 
 if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
end;

constructor TDSQL_metod.Create;
begin
 inherited Create;
 Fstmt_handle := nil;
 Fstr_dsql :='';
 FTrans :=nil;
end;

destructor TDSQL_metod.Destroy;
var status_vector : TStatus_vector;
begin
 if Fstmt_handle <> nil then begin

  SectionAccessToInterBase.Enter;
  try
    isc_dsql_free_statement(@status_vector,@Fstmt_handle,DSQL_drop);
  finally
    SectionAccessToInterBase.Leave;
  end;
  
  if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
 end;
 inherited Destroy;
end;

procedure TDSQL_metod1.Prepare(Connect : TConnection; Trans : TTransaction; str_ : string);
var status_vector : TStatus_vector;
begin
 if (Connect = nil) or (Trans = nil) then raise EIbaseError.Create(' Connect  Trans   .');

 SectionAccessToInterBase.Enter;
 try
   if Fstmt_handle <> nil then begin
    isc_dsql_free_statement(@status_vector,@Fstmt_handle,DSQL_drop);
    if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
   end;
   Fstmt_handle :=nil;
   Fstr_dsql :=''; FTrans :=nil;
   isc_dsql_allocate_statement(@status_vector,Connect.db_handle,@Fstmt_handle);
   if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
   isc_dsql_prepare(@status_vector,Trans.tr_handle,@Fstmt_handle,0,str_,Interbase_dialect,nil);
   if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
 finally
   SectionAccessToInterBase.Leave;
 end;

 Fstr_dsql :=str_; FTrans :=Trans;
end;

procedure TDSQL_metod1.Execute;
var status_vector : TStatus_vector;
begin
 if (Fstmt_handle = nil) or (FTrans = nil) then raise EIbaseError.Create('     prepare.');

 SectionAccessToInterBase.Enter;
 try
   isc_dsql_execute(@status_vector,FTrans.tr_handle,@Fstmt_handle,1,nil);
 finally
   SectionAccessToInterBase.Leave;
 end;

 if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
end;

constructor TXSQLDA.Create(quan : integer);
begin
 inherited Create;
 Fpointer_XSQLDA :=nil;
 if quan = 0 then raise EIbaseError.Create('    > 0');
 GetMem(Fpointer_XSQLDA,XSQLDA_LENGTH(quan));
 Fpointer_XSQLDA^.version :=SQLDA_VERSION1;
 Fpointer_XSQLDA^.sqln :=quan;
end;

destructor TXSQLDA.Destroy;
begin
 if Fpointer_XSQLDA <> nil then FreeMem(Fpointer_XSQLDA,XSQLDA_LENGTH(Fpointer_XSQLDA^.sqln));
 inherited Destroy;
end;

function TXSQLDA.GetXSQLVAR(index : integer) : Tpointer_XSQLVAR;
begin
 if (index < 0) or (index >= pointer_XSQLDA.sqln) then raise EIbaseError.Create('   index.');
 result := @Fpointer_XSQLDA^.sqlvar[0];
 inc(result,index);
end;

constructor TDSQL_metod2.Create;
begin
 inherited Create;
 FXSQLDA      :=nil;
end;

destructor TDSQL_metod2.Destroy;
begin
 FXSQLDA.Free;
 inherited Destroy;
end;

procedure TDSQL_metod2.Prepare(Connect : TConnection; Trans : TTransaction; str_ : string);
var status_vector : TStatus_vector;
    n : SmallInt;
begin
 if (Connect = nil) or (Trans = nil) then raise EIbaseError.Create(' Connect  Trans   .');

 SectionAccessToInterBase.Enter;
 try
   if Fstmt_handle <> nil then begin
    isc_dsql_free_statement(@status_vector,@Fstmt_handle,DSQL_drop);
    if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
   end;
   Fstmt_handle :=nil;
   Fstr_dsql :=''; FTrans :=nil;
   FXSQLDA.Free;
   FXSQLDA :=TXSQLDA.Create(1);
   isc_dsql_allocate_statement(@status_vector,Connect.db_handle,@Fstmt_handle);
   if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
   isc_dsql_prepare(@status_vector,Trans.tr_handle,@Fstmt_handle,0,str_,Interbase_dialect,FXSQLDA.pointer_XSQLDA);
   if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
   isc_dsql_describe_bind(@status_vector,@Fstmt_handle,1,FXSQLDA.pointer_XSQLDA);
   if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
   if FXSQLDA.pointer_XSQLDA^.sqld <> FXSQLDA.pointer_XSQLDA^.sqln then begin
     n :=FXSQLDA.pointer_XSQLDA^.sqld;
     FXSQLDA.Free;
     FXSQLDA :=TXSQLDA.Create(n);
     isc_dsql_describe_bind(@status_vector,@Fstmt_handle,1,FXSQLDA.pointer_XSQLDA);
     if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
   end;
 finally
   SectionAccessToInterBase.Leave;
 end;

 Fstr_dsql :=str_; FTrans :=Trans;
end;

procedure TDSQL_metod2.Execute;
var status_vector : TStatus_vector;
begin
 if (Fstmt_handle = nil) or (FTrans = nil) or (FXSQLDA = nil) then raise EIbaseError.Create('     prepare.');

 SectionAccessToInterBase.Enter;
 try
   isc_dsql_execute(@status_vector,FTrans.tr_handle,@Fstmt_handle,1,FXSQLDA.pointer_XSQLDA);
 finally
   SectionAccessToInterBase.Leave;
 end;
 
 if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
end;

function TDSQL_metod2.GetCountParametr : integer;
begin
 if FXSQLDA = nil then raise EIbaseError.Create('     prepare.');
 result :=FXSQLDA.pointer_XSQLDA.sqln;
end;

function TDSQL_metod2.GetParametr(index : integer) : Tpointer_XSQLVAR;
begin
 result := FXSQLDA.XSQLVAR_[Index];
end;

constructor TDSQL_metod3.Create;
begin
 inherited Create;
 FXSQLDA :=nil;
 FEof :=False;
 FIsOpen :=False;
end;

destructor TDSQL_metod3.Destroy;
begin
 FXSQLDA.Free;
 inherited Destroy;
end;

procedure TDSQL_metod3.Prepare(Connect : TConnection; Trans : TTransaction; str_ : string);
var status_vector : TStatus_vector;
    n : SmallInt;
begin
 if (Connect = nil) or (Trans = nil) then raise EIbaseError.Create(' Connect  Trans   .');

 SectionAccessToInterBase.Enter;
 try
   if Fstmt_handle <> nil then begin
    isc_dsql_free_statement(@status_vector,@Fstmt_handle,DSQL_drop);
    if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
   end;
   Fstmt_handle :=nil;
   Fstr_dsql :=''; FTrans :=nil;
   FXSQLDA.Free;
   FXSQLDA :=TXSQLDA.Create(1);
   isc_dsql_allocate_statement(@status_vector,Connect.db_handle,@Fstmt_handle);
   if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
   isc_dsql_prepare(@status_vector,Trans.tr_handle,@Fstmt_handle,0,str_,Interbase_dialect,nil);
   if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
   isc_dsql_describe(@status_vector,@Fstmt_handle,1,FXSQLDA.pointer_XSQLDA);
   if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
   if FXSQLDA.pointer_XSQLDA^.sqld <> FXSQLDA.pointer_XSQLDA^.sqln then begin
     n :=FXSQLDA.pointer_XSQLDA^.sqld;
     FXSQLDA.Free;
     FXSQLDA :=TXSQLDA.Create(n);
     isc_dsql_describe(@status_vector,@Fstmt_handle,1,FXSQLDA.pointer_XSQLDA);
     if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
   end;
 finally
   SectionAccessToInterBase.Leave;
 end;

 Fstr_dsql :=str_; FTrans :=Trans;
 FIsOpen :=False;
end;

procedure TDSQL_metod3.Open_cursor(cursor_name : string = '');
var status_vector : TStatus_vector;
begin
 if (Fstmt_handle = nil) or (FTrans = nil) then raise EIbaseError.Create('     Prepare.');
 if FIsOpen then  raise EIbaseError.Create('  .');

 SectionAccessToInterBase.Enter;
 try
   isc_dsql_execute(@status_vector,FTrans.tr_handle,@Fstmt_handle,1,nil);
   if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
   if cursor_name <> '' then begin
    isc_dsql_set_cursor_name(@status_vector,@Fstmt_handle,cursor_name,0);
    if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
   end;
 finally
   SectionAccessToInterBase.Leave;
 end;

 FIsOpen :=True; FEof :=False;
end;

procedure TDSQL_metod3.Close_cursor;
var status_vector : TStatus_vector;
begin
 if Fstmt_handle = nil then raise EIbaseError.Create('     Prepare.');
 if not FIsOpen then raise EIbaseError.Create('  .');

 SectionAccessToInterBase.Enter;
 try
   isc_dsql_free_statement(@status_vector,@Fstmt_handle,DSQL_close);
 finally
   SectionAccessToInterBase.Leave;
 end;

 if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
 FIsOpen :=False;
end;

procedure TDSQL_metod3.ReOpen_cursor(cursor_name : string = '');
begin
 if FIsOpen then Close_cursor;
 Open_cursor(cursor_name);
end;

procedure TDSQL_metod3.Fetch;
var A : ISC_STATUS;
    status_vector : TStatus_vector;
begin
 if (Fstmt_handle = nil) or (FXSQLDA = nil) then raise EIbaseError.Create('     prepare.');
 if not FIsOpen then raise EIbaseError.Create('     Open_cursor.');

 SectionAccessToInterBase.Enter;
 try
   A :=isc_dsql_fetch(@status_vector,@Fstmt_handle,1,FXSQLDA.pointer_XSQLDA);
 finally
   SectionAccessToInterBase.Leave;
 end;
 
 if A =0 then FEof :=False
  else if A =100 then begin FEof :=True; Close_cursor; end
  else raise EIbaseError.Create(GetError(status_vector));
end;

function TDSQL_metod3.GetCountFields : integer;
begin
 if FXSQLDA = nil then raise EIbaseError.Create('     prepare.');
 result :=FXSQLDA.pointer_XSQLDA.sqln;
end;

function TDSQL_metod3.GetField(index : integer) : Tpointer_XSQLVAR;
begin
 result := FXSQLDA.XSQLVAR_[Index];
end;

constructor TDSQL_metod4.Create(isParametr : boolean);
begin
 FIsParametrs :=isParametr;
 InputXSQLDA :=nil;
 inherited Create;
end;

destructor TDSQL_metod4.Destroy;
begin
 InputXSQLDA.Free;
 inherited Destroy;
end;

procedure TDSQL_metod4.Prepare(Connect : TConnection; Trans : TTransaction; str_ : string);
var status_vector : TStatus_vector;
    n : SmallInt;
begin
 if FIsParametrs then begin
   if (Connect = nil) or (Trans = nil) then raise EIbaseError.Create(' Connect  Trans   .');

   SectionAccessToInterBase.Enter;
   try
     if Fstmt_handle <> nil then begin
      isc_dsql_free_statement(@status_vector,@Fstmt_handle,DSQL_drop);
      if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
     end;
     Fstmt_handle :=nil;
     Fstr_dsql :=''; FTrans :=nil;
     InputXSQLDA.Free; FXSQLDA.Free;
     InputXSQLDA :=TXSQLDA.Create(1);
     FXSQLDA     :=TXSQLDA.Create(1);
     isc_dsql_allocate_statement(@status_vector,Connect.db_handle,@Fstmt_handle);
     if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
     isc_dsql_prepare(@status_vector,Trans.tr_handle,@Fstmt_handle,0,str_,Interbase_dialect,InputXSQLDA.pointer_XSQLDA);
     if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
     isc_dsql_describe_bind(@status_vector,@Fstmt_handle,1,InputXSQLDA.pointer_XSQLDA);
     if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
     if InputXSQLDA.pointer_XSQLDA^.sqld <> InputXSQLDA.pointer_XSQLDA^.sqln then begin
      n :=InputXSQLDA.pointer_XSQLDA^.sqld;
      InputXSQLDA.Free;
      InputXSQLDA :=TXSQLDA.Create(n);
      isc_dsql_describe_bind(@status_vector,@Fstmt_handle,1,InputXSQLDA.pointer_XSQLDA);
      if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
     end;
     isc_dsql_describe(@status_vector,@Fstmt_handle,1,FXSQLDA.pointer_XSQLDA);
     if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
     if FXSQLDA.pointer_XSQLDA^.sqld <> FXSQLDA.pointer_XSQLDA^.sqln then begin
      n :=FXSQLDA.pointer_XSQLDA^.sqld;
      FXSQLDA.Free;
      FXSQLDA :=TXSQLDA.Create(n);
      isc_dsql_describe(@status_vector,@Fstmt_handle,1,FXSQLDA.pointer_XSQLDA);
      if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
     end;
   finally
     SectionAccessToInterBase.Leave;
   end;

   Fstr_dsql :=str_; FTrans :=Trans;
   FIsOpen :=False;

 end else inherited Prepare(Connect,Trans,str_);
end;

procedure TDSQL_metod4.Open_cursor(cursor_name : string = '');
var status_vector : TStatus_vector;
begin
 if FIsParametrs then begin
   if (Fstmt_handle = nil) or (FTrans = nil) or (InputXSQLDA = nil) or (FXSQLDA = nil) then raise EIbaseError.Create('     Prepare.');
   if FIsOpen then  raise EIbaseError.Create('  .');

   SectionAccessToInterBase.Enter;
   try
     isc_dsql_execute2(@status_vector,FTrans.tr_handle,@Fstmt_handle,1,InputXSQLDA.pointer_XSQLDA,nil);
     if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
     if cursor_name <> '' then begin
      isc_dsql_set_cursor_name(@status_vector,@Fstmt_handle,cursor_name,0);
      if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
     end;
   finally
     SectionAccessToInterBase.Leave;
   end;

   FIsOpen :=True; FEof :=False;

 end else inherited Open_cursor(cursor_name);
end;

function TDSQL_metod4.GetCountParametrs : integer;
begin
 if InputXSQLDA = nil then raise EIbaseError.Create('     prepare.');
 result :=InputXSQLDA.pointer_XSQLDA^.sqln;
end;

function TDSQL_metod4.GetParametr(index : integer) : Tpointer_XSQLVAR;
begin
 result := InputXSQLDA.XSQLVAR_[Index];
end;

constructor TText_Blob.Create(db_handle_ : pointer = nil; tr_handle_ : pointer = nil);
begin
 inherited Create;
 Fblob_handle :=nil;
 Fdb_handle :=db_handle_;
 Ftr_handle :=tr_handle_;
end;

procedure TText_Blob.Read_Blob(SizeBuffer : SmallInt = DefaultSizeBuf_TText_Blob);
var
 status_vector : TStatus_vector;
 Buffer : PChar;
 len_reading,i,j : SmallInt;
 new_str : Boolean;
begin
{ Delphi 6  .   Copy:    s  PChar
   ,  , '12345'.  Copy(s,0,3)  Copy(s,1,3) 
       '123'.        Copy   Buffer
      1     0}

 Buffer :=StrAlloc(SizeBuffer);
 try
// Blob 
  SectionAccessToInterBase.Enter;
  try
    isc_open_blob2(@status_vector,Fdb_handle,Ftr_handle,@Fblob_handle,@FISC_QUAD,0,PChar(nil));
    if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
  finally
    SectionAccessToInterBase.Leave;
  end;

// 
  new_str :=True;
  while True do begin

   SectionAccessToInterBase.Enter;
   try
     isc_get_segment(@status_vector,@Fblob_handle,@len_reading,SizeBuffer,Buffer);
   finally
     SectionAccessToInterBase.Leave;
   end;

   if (status_vector[0] = 1) and (status_vector[1] = isc_segstr_eof) then break;
   if (status_vector[0] = 1) and (status_vector[1] <> 0) and (status_vector[1] <> isc_segment) then raise EIbaseError.Create(GetError(status_vector));
   j :=0;
   for i :=0 to len_reading -1 do
    if Buffer[i] =  EndOfStr_TText_Blob then begin
     if new_str
      then Add(Copy(Buffer,j+1,i-j))
      else Strings[Count-1] :=Strings[Count-1] + Copy(Buffer,j+1,i-j);
     j :=i+1;
     new_str :=True;
    end;
   if j < len_reading then begin
    if new_str
     then Add(Copy(Buffer,j+1,len_reading-j))
     else Strings[Count-1] :=Strings[Count-1] + Copy(Buffer,j+1,len_reading-j);
    new_str :=False;
   end;
  end;
// Blob 
  SectionAccessToInterBase.Enter;
  try
    isc_close_blob(@status_vector,@Fblob_handle);
  finally
    SectionAccessToInterBase.Leave;
  end;
  if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
 finally
  StrDispose(Buffer);
 end;
end;

procedure TText_Blob.Write_Blob;
var
 status_vector : TStatus_vector;
 i : integer;
begin
// Blob 
 SectionAccessToInterBase.Enter;
 try
   isc_create_blob2(@status_vector,Fdb_handle,Ftr_handle,@Fblob_handle,@FISC_QUAD,0,PChar(nil));
   if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
// Blob 
   for i:=0 to Count -1 do begin
    isc_put_segment(@status_vector,@Fblob_handle,length(Strings[i]) +1,Strings[i] + EndOfStr_TText_Blob);
    if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
   end;
// Blob 
   isc_close_blob(@status_vector,@Fblob_handle);
   if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
 finally
   SectionAccessToInterBase.Leave;
 end;
end;

procedure TDSQL_metod4.ExecuteProc;
var status_vector : TStatus_vector;
begin
 if (Fstmt_handle = nil) or (FTrans = nil) or (InputXSQLDA = nil) or (FXSQLDA = nil) then raise EIbaseError.Create('     Prepare.');
 if FIsOpen then  raise EIbaseError.Create('  .');

 SectionAccessToInterBase.Enter;
 try
   isc_dsql_execute2(@status_vector,FTrans.tr_handle,@Fstmt_handle,1,InputXSQLDA.pointer_XSQLDA,FXSQLDA.pointer_XSQLDA);
   if (status_vector[0] = 1) and (status_vector[1] <> 0) then raise EIbaseError.Create(GetError(status_vector));
 finally
   SectionAccessToInterBase.Leave;
 end;
end;

function TDPB.ReadRole: string;
begin
 result :=FParametrDPB.role;
end;

{ TIB_Events }
//       !!!
//------------------------------------------------------------
procedure CallBackForEvent(ib_event: TIB_Events; length_: short; updated : PChar); cdecl;
var i,l : integer;
    status_vector : TStatus_vector;
    n : array of string;
    flagOK : boolean;
begin
 flagOK :=false;
 try
   Move(updated[0], ib_event.FResult_buffer[0], length_);

   isc_event_counts(@status_vector,length_,ib_event.FEvent_buffer,ib_event.FResult_buffer);
   l :=0;
   for i :=0 to ib_event.FEventsList.Count -1 do
     if status_vector[i] <> 0 then inc(l);

   SetLength(n,l); l :=0;
   for i :=0 to ib_event.FEventsList.Count -1 do
     if status_vector[i] <> 0 then begin
       n[l] := ib_event.FEventsList.Strings[i];
       inc(l);
     end;

   isc_que_events(@status_vector,@ib_event.FConnection.Fdb_handle,@ib_event.FEvent_id,length_,
                  ib_event.FEvent_buffer,@CallBackForEvent,ib_event);
   if (status_vector[0] = 1) and (status_vector[1] <> 0) then
     raise EIbaseError.Create(GetError(status_vector));

   flagOK :=true;
   if (l > 0) and Assigned(ib_event.OnEvents) and not ib_event.FflagFirst then
     ib_event.OnEvents(n);

   ib_event.FflagFirst :=false;
 finally
  if not flagOK then begin
    ib_event.FEventsList.Clear;
    ib_event.FFlagRegistration :=false;
    if ib_event.FEvent_buffer  <> nil then isc_free(ib_event.FEvent_buffer);
    if ib_event.FResult_buffer <> nil then isc_free(ib_event.FResult_buffer);
  end;
 end;
end;

constructor TIB_Events.Create(connect: TConnection);
begin
 inherited Create;
 FConnection :=connect;
 FEvent_buffer :=nil;
 FResult_buffer:=nil;
 FFlagRegistration :=false;
 FEventsList :=TStringList.Create;
 FEvent_id :=0;
 OnEvents :=nil;
end;

destructor TIB_Events.Destroy;
begin
 if FlagRegistration then UnRegistration;
 FEventsList.Free;
 inherited Destroy;;
end;

procedure TIB_Events.Registration(name_events: array of string);

 function GetNameEvent(index : integer) : PChar;
  begin
    if (index < low(name_events)) or (index > high(name_events))
     then Result :=nil
     else Result :=PChar(name_events[index]);
  end;

var i : integer;
    lBuffer : LongInt;
    status_vector : TStatus_vector;
    flagOK : boolean;
begin
 if FFlagRegistration then raise EIbaseError.Create('   . , ,    .');

 flagOK :=false;
 try
   if length(name_events) > 15 then raise EIbaseError.Create('       15. , ,    .');

   FEventsList.Clear;
   for i :=low(name_events) to high(name_events) do
     FEventsList.Add(AnsiUpperCase(name_events[i]));

   lBuffer :=isc_event_block(@FEvent_buffer,@FResult_buffer,length(name_events),
                             GetNameEvent(0), GetNameEvent(1), GetNameEvent(2),
                             GetNameEvent(3), GetNameEvent(4), GetNameEvent(5),
                             GetNameEvent(6), GetNameEvent(7), GetNameEvent(8),
                             GetNameEvent(9), GetNameEvent(10),GetNameEvent(11),
                             GetNameEvent(12),GetNameEvent(13),GetNameEvent(14));

   FflagFirst :=true;
   isc_que_events(@status_vector,@FConnection.Fdb_handle,@FEvent_id,lBuffer,
                  FEvent_buffer,@CallBackForEvent,self);
   if (status_vector[0] = 1) and (status_vector[1] <> 0) then
     raise EIbaseError.Create(GetError(status_vector));

   FFlagRegistration :=true;
   flagOK :=true;

 finally
  if not flagOK then begin
    FEventsList.Clear;
    FFlagRegistration :=false;
    if FEvent_buffer <> nil then isc_free(FEvent_buffer);
    if FResult_buffer <> nil then isc_free(FResult_buffer);
  end;
 end;
end;

procedure TIB_Events.UnRegistration;
var status_vector : TStatus_vector;
begin
 if not FFlagRegistration then raise EIbaseError.Create('   . , ,    .');

 isc_cancel_events(@status_vector,@FConnection.Fdb_handle,@FEvent_id);
 if (status_vector[0] = 1) and (status_vector[1] <> 0) then
   raise EIbaseError.Create(GetError(status_vector));

 FFlagRegistration :=false;
 FEventsList.Clear;
 if FEvent_buffer <> nil then isc_free(FEvent_buffer);
 if FResult_buffer <> nil then isc_free(FResult_buffer);
end;

initialization
 Interbase_dialect :=1;
 SectionAccessToInterBase :=TCriticalSection.Create;

finalization
 SectionAccessToInterBase.Free;

end.
