unit iberror;

interface
 uses ibase,ibase_level1_server;

// ISC Error Codes
const
 error_isc_io_error    =335544344;
 error_isc_not_valid   =335544347;
 error_isc_no_priv     =335544352;
 eroor_isc_foreign_key =335544466;
 error_isc_login       =335544472;
 error_isc_io_open_err =335544734;

type
 TMessage_isc_error_rus =class(TObject)
  protected
   function replace(s : string) : string; virtual;
   function getAddInfo(status_vector : TStatus_vector; index : integer) : string;
   function getMessage_eng(status_vector : TStatus_vector; index : integer) : string;
   function getNextError(status_vector : TStatus_vector; index : integer) : integer;
  public
   function getMessage(status_vector : TStatus_vector) : string;
 end;

var Message_isc_error_rus : TMessage_isc_error_rus;
    defaultMessage_isc_error_rus : TMessage_isc_error_rus;

implementation

uses SysUtils;

{ TMessage_isc_error_rus }
function TMessage_isc_error_rus.getAddInfo(status_vector : TStatus_vector; index : integer): string;
var s : string;
begin
 Result :='';
 while (status_vector[index] <> isc_arg_end) and (status_vector[index] <> isc_arg_gds) do begin
  s :='';
  case status_vector[index] of
   isc_arg_string      : begin inc(index); s :=PChar(status_vector[index]); end;
   isc_arg_cstring     : inc(index,2);
   isc_arg_interpreted : begin inc(index); s :=PChar(status_vector[index]); end;
   else inc(index);
  end;

  if  s <> '' then begin
    s :=replace(s);
    if Result <> '' then Result :=Result + ',';
    Result :=Result + s;
  end;

  inc(index);
 end;

 if Result <> '' then Result :=' : '+ Result;
end;

function TMessage_isc_error_rus.getMessage(status_vector: TStatus_vector): string;
var i : integer;
    s : string;
begin
 result :=''; i :=0;
 while status_vector[i] <> isc_arg_end do begin
   s :='';
   if status_vector[i+1] =error_isc_login then
     s :='     .         .'
    else if status_vector[i+1] =eroor_isc_foreign_key then
     s :='  . ' + getAddInfo(status_vector,i+2)
    else if status_vector[i+1] =error_isc_not_valid then
     s :=' . ' + getAddInfo(status_vector,i+2)
    else if status_vector[i+1] =error_isc_no_priv then
     s :='       . ' + getAddInfo(status_vector,i+2)
    else if status_vector[i+1] =error_isc_io_error then
     s :=' / . ' + getAddInfo(status_vector,i+2)
    else if status_vector[i+1] =error_isc_io_open_err then
     s :='     . ' + getAddInfo(status_vector,i+2)
    else s :=getMessage_eng(status_vector,i);

   if s <> '' then begin
     if result <> '' then result :=result + #13;
     result :=result + s;
   end;
   i :=getNextError(status_vector,i);
 end;
end;

function TMessage_isc_error_rus.getMessage_eng(status_vector: TStatus_vector; index: integer): string;
var str_ : PChar;
    A    : pointer;
begin
 Result :='';
 str_ :=StrAlloc(512); // 
 try
  A :=@(status_vector[index]);
  if isc_interprete(str_,@A) <> 0 then result :=str_
   else result :=' getMessage_end. isc_interprete   . , ,    .';
 finally
  StrDispose(str_); // 
 end;
end;

function TMessage_isc_error_rus.getNextError(status_vector: TStatus_vector; index: integer): integer;
begin
 inc(index);
 while (status_vector[index] <> isc_arg_end) and (status_vector[index] <> isc_arg_gds) do
  inc(index);

 result :=index;
end;

function TMessage_isc_error_rus.replace(s: string): string;
begin
 result :=s;
end;

initialization
 defaultMessage_isc_error_rus :=TMessage_isc_error_rus.Create;
 Message_isc_error_rus :=nil;

finalization
 defaultMessage_isc_error_rus.Free;

end.